package gq.unurled.elixium.commands.player;

import gq.unurled.elixium.Elixium;
import gq.unurled.elixium.manager.PlayerManager;
import gq.unurled.elixium.manager.ProfileManager;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

import static gq.unurled.elixium.utils.Utils.*;

public class StorageCommand implements TabExecutor {

    private ProfileManager profileManager = Elixium.getProfileManager();

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(!(sender instanceof Player)) {
            error("The console can't execute this Command!");
            return true;
        }
        Player player = (Player) sender;
        Inventory inv;
        switch (args.length) {
            case 0:
                if(profileManager.getPlayerStorage(player.getUniqueId()) != null) {
                    inv = profileManager.getPlayerStorage(player.getUniqueId()).getEc().getEc();
                }
                else {
                    profileManager.createNewStorage(player);
                    inv = profileManager.getPlayerStorage(player.getUniqueId()).getEc().getEc();
                }
                player.openInventory(inv);

                break;
            case 1:
                Player p = Bukkit.getPlayer(args[0]);
                if(p == null) {
                    msgPlayer(player, color("&cYou can't open the Storage of an unknown Player."));
                    return true;
                }
                inv = profileManager.getPlayerStorage(p.getUniqueId()).getEc().getEc();
                player.openInventory(inv);
                break;
        }
        return true;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        return null;
    }
}
